/* This program is a simple money balancing accounting program 
   Brian Tabone Dec 5 1998 

   Conventions: Methods for a class are prefixed with the name of the class.
   Passed in variables, for a class method, are the same name as the method,
   minus the class name prefix. 
*/
 
#include "FreeMoney.h"  /* #include "FreeMoney.h" must be the first include */
#include "Credit_Card_Manager.h"

/* Standard C Function Declare Section */
void Main_Menu();
void Create_new_account();
void View_account();
int File_Manager(menu_id, short);

/* Class method definitions , see MoneyData.h for class definition */  
/* See FreeMoney_File_Management.cpp for MoneyData::MoneyData_Write_to_file */

#include "FreeMoney_File_Management.cpp"
#include "FreeMoney_DBFile_Management.cpp" 		
#include "Create_Account.cpp"

/* Begin standard C style function definitions */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

void Main_Menu()
{
	char *Main_Menu_Choice;
	char Process_Menu_Choice[1]; 

	/* Set Menu id for Help menu */
	Menu_id = MAIN;

	Main_Menu_Choice = (char *)malloc(20);	

	memset(Main_Menu_Choice,'\0',sizeof(*Main_Menu_Choice));
	move(15,5);	
	printw("%s", "Please choose from the following menu.");
	/* Main Menu Choices */
	move(16, 5);
	printw("%s", "1.	Create new account");
	move(17, 5);
	printw("%s", "2.	Edit existing account");
	move(18, 5);
	printw("%s", "3.	Delete existing account");
	move(19, 5);
	printw("%s",  "4.	View account");
	move(20, 5);
	printw("%s",  "5.	Credit Card Manager");
        move(21, 5);
	printw("%s",  "6.	Exit from Money Data");
	move(22, 5);
	printw("%s",  "Or enter Help for help with Money Data");
	/* Prompt user for choice */
	move(23, 5);
	printw("%s",  "Please enter the number corresponding to your choice: ");
	refresh();
	scanw("%s",Main_Menu_Choice);
	memcpy(Process_Menu_Choice, Main_Menu_Choice, sizeof(*Process_Menu_Choice));	
	/* Process Main Menu Choice */
	switch(Process_Menu_Choice[0]) {
	case '1': 
		delete(Main_Menu_Choice);
		Create_new_account();
		break;

	case '2': 
		delete(Main_Menu_Choice);
		// Edit_account();
		break;

	case '3': 
		delete(Main_Menu_Choice);
		// Delete_account();
		break;

	case '4': 
		delete(Main_Menu_Choice);
		View_account();
		break;

	case '5': 
		delete(Main_Menu_Choice);
		Credit_Card_Manager();
		break;

	case '6': 
		delete(Main_Menu_Choice);
		endwin();	
		exit(0);
		break;
		
	case 'H':
		delete(Main_Menu_Choice);
		File_Manager(Menu_id, HELP_FILE);
		break;
	case 'h': 
		delete(Main_Menu_Choice);
		File_Manager(Menu_id, HELP_FILE);
		break;
	
	default:	
		move(23, 5);
		printw("%s %s %s","Oops,", Main_Menu_Choice, "is not a valid option, please choose again");
		refresh();
		sleep(2);
		delete(Main_Menu_Choice);
		
		clear();
		Main_Menu();
		break;
	} // End switch statement
}

void View_account()
{
	MoneyData View_Account;
	char Account_to_view[MAX_STRING];
	char write_to_screen[MAX_STRING];
	char Type[MAX_STRING]; /* Show the user Deposit or Withdrawal, not 0 or 1 */
	char Wait_to_continue;
	FILE *account_file;
	int row = 3;

	/* File data types */
	int 	Trans_id;
	time_t	Time_stamp; 
	char 	Trans_description[MAX_STRING];
	int	Trans_type; /* 0 for deposit, 1 for withdrawal */
	float	Trans_amount;	
	float	Resultant_balance;
	
Try_Again:
	clear();
	move(5,5);
	printw("Enter the account identifier of the account you wish to view");
	move(6,5);
	printw(": ");
	refresh();
	getnstr(Account_to_view, MAX_STRING);
#ifdef TEXT_FILE
	strcat(Account_to_view, "_FreeMoney.txt");
#else
	strcat(Account_to_view, "_FreeMoney.db");
#endif
	move(0,0);
	refresh();
	if ((account_file = fopen(Account_to_view, "r")) == NULL) {
		move(10,5);
		printw("I could not oppen the file, check the file name");
		refresh();
		sleep(1);
		clear();
		/* I hate goto statements, I really hate goto statments */
		goto Try_Again;
	} 

	clear();

#ifdef TEXT_FILE
	do {		
		fscanf(account_file, "%d%d%s%d%f%f", 	&Trans_id, 
							&Time_stamp, 
							Trans_description, 
							&Trans_type, 
							&Trans_amount, 
							&Resultant_balance);
		if(feof(account_file)) 
			break; 
		/* a Kludge to keep the last line from printing twice */
	
		mvwprintw(stdscr, 0, 2, "Id    Description    Type         Amount    Balance");

		if(Trans_type==0) {
			strcpy(Type, "Deposit");
		}
		else {
			strcpy(Type, "Withdrawal");
		}

		mvwprintw(stdscr, row, 2, "%d", Trans_id);
		mvwprintw(stdscr, row, 8, "%s", Trans_description); 
		/* We are going to have problems with long descriptions!*/
		mvwprintw(stdscr, row, 23, "%s", Type);
		mvwprintw(stdscr, row, 36, "%.2lf", Trans_amount);
		mvwprintw(stdscr, row, 46, "%.2lf", Resultant_balance);
		refresh();
		row ++;
		if (row == 18) {
		mvwprintw(stdscr, 20, 2, "Press enter to continue");
		scanw(&Wait_to_continue);
		row = 3;
		clear();
		}
	}while(!feof(account_file)); 

	if (row < 18) {
	mvwprintw(stdscr, 20, 2, "Press enter to continue");
	scanw(&Wait_to_continue);
	}
#else
	View_Account.MoneyData_Money_DB(LIST, NULL, Account_to_view);		
#endif
}
int File_Manager(menu_id Calling_Menu, short File_Type)
{
	FILE *file_pointer;

	switch(File_Type) {
		
		case 0: {
			/* Nested case statement for different types of help files 
			   Note that names of help files are fixed at install time*/
		switch(Calling_Menu) { 
			
			case MAIN: {
			if((file_pointer=fopen("./MoneyDataHelpFiles/Main_Menu_Help.hlp","r"))==NULL) {
				clear();
				move(3,5);
				printw("%s",  "There has been an error in opening the help file.\n");
				move(4, 5);
				printw("%s",  "Please check to see if the help files were installed\n");
				move(5, 5);
				printw("%s",  "in a directory called MoneyDataHelpFiles under the same\n");
				move(6, 5);
				printw("%s",  "directory as the executable"); 
				refresh();
				sleep(2);
				return 1;
			}
			Display_file(file_pointer); //Routine for displaying files on screen
			break;
			}// End case MAIN
				
			default: return 1;
			} // End switch(Calling_Menu)
			} // End case 0
	
		defualt: return 1; 
	}	
	fclose(file_pointer);	
	return 0;
} // end File_Manager definition
		
int main(int argc, char *argv[])
{
	initscr();
	move(2, 5);
	printw("%s", "Welcome to Free Money for Linux\n");
	move(3, 5);
	printw("%s", "Copyleft Brian Tabone, V 0.0.7 BETA, No Warranty, use at your own risk");
	refresh();
MAIN:
	Main_Menu();
	clear();
	refresh();
	goto MAIN;	
	endwin();
	exit(0);
}
		
