/* Header file for FreeMoney finance management program, this file contains 
mostly definitions for file handling routines, will become more structured 
as time goes on.  */

#include<iostream.h>
#include<errno.h>
#include<fcntl.h>
#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<time.h>
#include<string.h>
#include<curses.h>
#include<db.h>


/* Global Declare Section */

typedef enum {MAIN, HELP, DELETE, EDIT, SECURITY} menu_id;
typedef enum {NEW, MODIFY, ADD, OLD, LIST, QUERY} DISPOSITION; /* File disposition enumeration */

#define MAX_STRING 80

enum TRANS_TYPE {DEPOSIT, WITHDRAWAL};

typedef struct {
	char Account_ID[MAX_STRING];
        int Trans_id;
        char Trans_description[MAX_STRING];
        enum TRANS_TYPE Trans_type;
        long Trans_amount;
	long Trans_previous_balance; 
	time_t  Time_stamp;
/* Trans_previous_balance will be read in when the account file is opened for
the first time per instance of Free Money */
} ACCOUNT; 


extern void Write_to_file (struct ACCOUNT *account);
void Credit_Card_Manager();
void Main_Menu();

#define HELP_FILE 0 /* These #defines are the file types handled by the File_Manager */
#define ACCOUNT_FILE 1
#define LOG_FILE 2

menu_id Menu_id;

/* This section is a class definition , it is the main data structure for
   The program */

class MoneyData
{
	public:
	
	int  MoneyData_Money_DB(DISPOSITION disposition, char * KEYVALUE, char * file_to_open);
	void MoneyData_New_account();
	void MoneyData_Write_to_file(DISPOSITION);
	
	private: 

	struct 
	{
		char  account[100];
		float Previous_balance;
		float CurrentBalance;
		float AmountSpent;	
		float AmountDeposited;
		char  Description[100];
		time_t  Time_stamp;
	} MoneyDataStruct;

	struct 
	{
	char Account_ID[MAX_STRING];
        int Trans_id;
        char Trans_description[MAX_STRING];
        enum TRANS_TYPE Trans_type;
        float Trans_amount;
	float Trans_previous_balance; 
	time_t  Time_stamp;
/* Trans_previous_balance will be read in when the account file is opened for
the first time per instance of Free Money */
	} account; 
};		

int Display_file(FILE * file_pointer)
{
	int rows; 
	int columns; 
	int file_char;
	char * OKAY;
	OKAY = (char *)malloc(20);
	if (OKAY==NULL) return 1;
	clear();
	while(strcmp(OKAY, "OK")) {
		for(rows=2;rows<23;rows++) {
		move(rows,1);	
			for(columns=0;columns<80;columns++) {
				file_char = fgetc(file_pointer);
				if(file_char == EOF) return 0;
				addch(file_char);
			}
		refresh();
		}
	move(24,1);
	printw("%s", "Press enter to continue, or enter OK to return to the menu");
	scanw("%s", OKAY);
	} // End While loop		
	delete OKAY;
	return 0;
}
