/**********************************************************************
 *	This section of code is a change in File Management. Instead  *
 * 	of flat text files, I am switching to Berkley database files  *
 *	I will use DB_TREE as the database type. Records will be      *
 *      keyed by the unique time they are created. If there is time   *
 * 	skew noticed, then Free Money will compensate. This might     *
 *	occur if the time is off on the users computer, and then the  *
 * 	file is modified on a computer with good time. You can't have *
 * 	records made at the end of the database, then have new ones   *
 *	come earlier. Anyhow, here it goes			      *
 **********************************************************************/
int MoneyData::MoneyData_Money_DB(DISPOSITION disposition, char * KEYVALUE, char * file_to_open)
{
	DB * Money_db;

	DBT key_Account_ID,
	    key_Trans_description,
	    key_Trans_type,
	    key_Trans_amount,
   	    key_Trans_previous_balance,
	    key_List;

	DBT value_Account_ID,
	    value_Trans_description,
	    value_Trans_type,
	    value_Trans_amount,
   	    value_Trans_previous_balance,
	    value_List;

	char filename[100];
	char Type[MAX_STRING];
	char string_time_stamp[80];
	int flags, row, column, index;
	FILE * temp_file_pointer;
	struct flock lock;	
	struct {
		char Account_ID[MAX_STRING];
		char Trans_description[MAX_STRING];
		char Trans_type[MAX_STRING];
		char Trans_amount[MAX_STRING];
		char Trans_previous_balance[MAX_STRING];
	} KEY;

	struct {
		char Date[MAX_STRING];
		char Account_ID[MAX_STRING];
		char Trans_description[MAX_STRING];
		TRANS_TYPE Trans_type;
		double Trans_amount;
		double Trans_previous_balance;
	} SESSION_STRUCT[30];		
	
	lock.l_whence = SEEK_SET;
	lock.l_start = 0;
	lock.l_len = 0;
	
	if(disposition == NEW) {
		flags = O_CREAT | O_RDWR;
		lock.l_type = F_WRLCK;
	} else if (disposition == MODIFY || disposition == ADD) {
		flags = O_RDWR;
		lock.l_type = F_WRLCK;
	} else if (disposition == LIST) {
		flags = O_RDONLY; 
		lock.l_type = F_RDLCK;
	} else {
		flags = O_RDONLY;
		lock.l_type = F_RDLCK;
	}

	if(disposition==NEW) {
		strcpy(filename, account.Account_ID);		
		strcat(filename, "_FreeMoney.db");
	} else {
		strcpy(filename, file_to_open);
	}

	Money_db = dbopen(filename, flags, 0600, DB_HASH, NULL);
	if (!Money_db) {
		fprintf(stderr, "Failed to open %s: %s\n", filename, 
	  		strerror(errno));
		
		return 1;
	}

	if (fcntl(Money_db->fd(Money_db), F_SETLK, &lock)) {
		clear();
		move(5,5);
		if (errno == EAGAIN)
			printw("the phone database is already "
					"locked");
		else
			printw("failed to lock database: %s",
					strerror(errno));
		refresh();
		sleep(1);
		return 1;
	}

if(disposition==NEW || disposition==ADD) {

/**************************************************************
 * Set up Key values. These values are account.Time_stamp     *		
 * This is done by					      * 
 * fprintf(TEMP_FILE, "%d", account.Time_stamp)               *
 * into a temp file in /tmp, and then reading from this file  *
 * This is done to get the time stamp into string form. I am  *
 * sure there is a better way, but I am too lazy to worry     *
 * it right now PLEASE NOTE THAT CURRENTLY, IF THER IS        *
 * MORE THAN ONE USER AT A TIME, THIS FILE WILL GET CLOBBERED *
 * AND FREEMONEY WONT WORK, THIS WILL BE FIXED SOON           *
 **************************************************************/

	/* Write the integer time stamp as text to a text file */
	if((temp_file_pointer = fopen("/tmp/Free_Money_temp.tmp","w")) == NULL) 
		{
			perror("open");
			exit(1);
		}
	fprintf(temp_file_pointer, "%d", account.Time_stamp);
	fclose(temp_file_pointer);

	/* Read back the time stamp from the text file in temp */	
	if((temp_file_pointer = fopen("/tmp/Free_Money_temp.tmp","r")) == NULL)
		{
			perror("open");
			exit(1);
		}
	fscanf(temp_file_pointer, "%s", string_time_stamp);
	fclose(temp_file_pointer);		

	/* Set up the Key Values */
	strcpy(KEY.Account_ID, string_time_stamp);
	strcpy(KEY.Trans_description, string_time_stamp);
	strcpy(KEY.Trans_type, string_time_stamp);
	strcpy(KEY.Trans_amount, string_time_stamp);
	strcpy(KEY.Trans_previous_balance, string_time_stamp);

	strcat(KEY.Account_ID, "_Account_ID");
	strcat(KEY.Trans_description, "_Trans_description");
	strcat(KEY.Trans_type, "_Trans_type");
	strcat(KEY.Trans_amount, "_Trans_amount");
	strcat(KEY.Trans_previous_balance, "_Trans_previous_balance");
	

/* Add these records to the database */
	
	key_Account_ID.data = KEY.Account_ID;
	key_Account_ID.size = strlen(KEY.Account_ID) + 1;

	key_Trans_description.data = KEY.Trans_description;
	key_Trans_description.size = strlen(KEY.Trans_description) + 1;

	key_Trans_type.data = KEY.Trans_type;
	key_Trans_type.size = strlen(KEY.Trans_type) + 1;

	key_Trans_amount.data = KEY.Trans_amount;
	key_Trans_amount.size = strlen(KEY.Trans_amount) + 1;

   	key_Trans_previous_balance.data = KEY.Trans_previous_balance;
	key_Trans_previous_balance.size = 
		strlen(KEY.Trans_previous_balance) + 1;

/*The KEY values are set up, now for the value values.Now that's true value! */

	value_Account_ID.data = account.Account_ID;
	value_Account_ID.size = strlen(account.Account_ID) + 1;

	value_Trans_description.data = account.Trans_description;
	value_Trans_description.size = strlen(account.Trans_description) + 1;

	value_Trans_type.data = &account.Trans_type;
	value_Trans_type.size = sizeof(account.Trans_type) + 1;

	value_Trans_amount.data = &account.Trans_amount;
	value_Trans_amount.size = sizeof(account.Trans_amount) + 1;

   	value_Trans_previous_balance.data = &account.Trans_previous_balance;
   	value_Trans_previous_balance.size = 
		sizeof(account.Trans_previous_balance) + 1;
	
/* Write data to database */

	if(Money_db->put(Money_db, &key_Account_ID, &value_Account_ID, 0)) {
		clear();
		move(5,5);
		printw("I can't write the record to the database!");
		exit(1);
	}
	
	if(Money_db->put(Money_db, &key_Trans_description, &value_Trans_description, 0)) {
		clear();
		move(5,5);
		printw("I can't write the record to the database!");
		exit(1);
	}

	if(Money_db->put(Money_db, &key_Trans_type, &value_Trans_type, 0)) {
		clear();
		move(5,5);
		printw("I can't write the record to the database!");
		exit(1);
	}
	
	if(Money_db->put(Money_db, &key_Trans_amount, &value_Trans_amount, 0)) {
		clear();
		move(5,5);
		printw("I can't write the record to the database!");
		exit(1);
	}

	if(Money_db->put(Money_db, &key_Trans_previous_balance, &value_Trans_previous_balance, 0)) {
		clear();
		move(5,5);
		printw("I can't write the record to the database!");
		exit(1);
	}
	
	Money_db->close(Money_db);
   } /* End of if(disposition==NEW) */

if(disposition==LIST) {
	row = 0;
	index = 0;
	column = 0;
	flags = R_FIRST;
	while(!(Money_db->seq(Money_db, &key_List, &value_List, flags))) {
		flags = R_NEXT;
	switch(row) {
		case 0 :	 
			strncpy(SESSION_STRUCT[column].Date,(char *)key_List.data, 9);
			/* Set up the date for this transaction ^*/
			
			strncpy(SESSION_STRUCT[column].Account_ID, (char *)value_List.data, 
				value_List.size);
			/* Place account ID in every transaction listing, this is probably unecessary */
			break;

		case 1 :
			strncpy(SESSION_STRUCT[column].Trans_description, (char *)value_List.data, 
				value_List.size);
			break;

		case 2 :
			SESSION_STRUCT[column].Trans_type = *(TRANS_TYPE *)value_List.data;
			break;

		case 3 :
			SESSION_STRUCT[column].Trans_amount = *(float *)value_List.data;
			break;
		
		case 4 :
			SESSION_STRUCT[column].Trans_previous_balance = *(float *)value_List.data;
			column ++;
			row = 0;		
			break;
		
		default: 
			fprintf(stderr, "Oh shit, we shouldn't be here :( !! Fatal error in FreeMoney_DB"
				"File_Management.cpp module. Check near line 257!\n");
			exit(1);
			break;
		}
	row ++;
	}	
	Money_db->close(Money_db);
	move(2,5);
	printw("Account\tDescription\tTransaction\tAmount\tPrevious Balance");
	move(5,5);
	while((index < row) && (index < 35)){

	if(SESSION_STRUCT[index].Trans_type == 0) {
		strcpy(Type, "Deposit");
	} else {
		strcpy(Type, "Withdrawal");
	}

	printw("%s\t%s\t%s\t\t%.2lf\t%.2lf\n", SESSION_STRUCT[index].Account_ID, 
					   SESSION_STRUCT[index].Trans_description,
					   Type,
					   SESSION_STRUCT[index].Trans_amount,
					   SESSION_STRUCT[index].Trans_previous_balance);
	refresh();
	move((5+index),5);
	index++;
	} /* End while loop */
	
	sleep(4);
} /* End of if(disposition==LIST) */
	return 0;
}
