/****************************************************************************
 * This cpp file contains the code for the file management under Free Money *
 * The File standard for FreeMoney is as follows:			    *
 * 1) Each account shall have its own comma delimited file                  *
 * 2) Each file shall have comma delimited records with the following fields*
 * 	a. Trans_id: The transaction ID, this will be handled by FreeMoney  *
 *	b. Trans_description: Description of the transaction		    *
 *	c. Trans_type: Withdrawal or deposit				    *
 *	d. Trans_ammount: Ammount of transaction			    *
 *	e. Previous_balance:	Balance from previous transaction	    *
 *	f. Current_balance:	Balance as a result of transaction	    *
 *	g. Time_stamp:		Time stamp in seconds since epoch	    *	
 ****************************************************************************/
/* These are the account specific externally defined fields. */
/* Note that this is now a class method, Brian Tabone 03/07/1999 */
void MoneyData::MoneyData_Write_to_file (DISPOSITION disposition)
{
	FILE *account_file;
	char filename[100];
	float Resultant_balance;
	strcpy(filename, account.Account_ID);		
	strcat(filename, "_FreeMoney.txt");
	
	if (disposition == OLD) {
	if ((account_file = fopen(filename, "a+"))==NULL) {
	move(5,3);
	printw("I could not open the file, check permissions");
	refresh();
	sleep(2);
	endwin;
	exit(1);
	}
	}

	else {
	if ((account_file = fopen(filename, "w"))==NULL) {
        move(5,3);
        printw("I could not open the file, check permissions");
        refresh();
        sleep(2);
        endwin;
        exit(1);   
	}
	}

	/* write to the file */	
	account.Trans_id++;
	if (account.Trans_type == DEPOSIT) {
	if (disposition == NEW) account.Trans_previous_balance = 0;
	Resultant_balance = (account.Trans_previous_balance + account.Trans_amount);
	}
	else Resultant_balance = (account.Trans_previous_balance - account.Trans_amount);

	fprintf(account_file, "%d\n", account.Trans_id);
	fprintf(account_file, "%d\n", account.Time_stamp);
	fprintf(account_file, "%s\n", account.Trans_description);
	fprintf(account_file, "%d\n", account.Trans_type);
	fprintf(account_file, "%.2lf\n", account.Trans_amount);
	fprintf(account_file, "%.2lf\n", Resultant_balance);

	fclose(account_file);

} /* End File write routine */
